/*
    Project: TCGINA (Keyfile Library/Editor V1.0f)
    Version: V1.15
    File   : kfipriv.h

    Copyright (c) 2005-2006 Author of TCGINA DLL. All rights reserved.

    Covered by TrueCrypt License 2.1 the full text of which is contained
    in the file License.txt included in TCGINA binary and source code
    distribution archives.

    The copyright notice of this source code file and the following public key
    must be retained in full.

-----BEGIN PGP PUBLIC KEY BLOCK-----
Version: GnuPG v1.2.4 (MingW32)

mQGiBEI3cVwRBADCRqJ1+AKeMw4BagfF9yNdobBBJXTFQ0R3RJHRAOoKMrT5rxMn
zjRvN9SugcTAftMRVTmsHVZcve6jO2yLHJLg2QgtHiRKdbLV9MTrzYtxXUL1Ez0A
3Mq6ww/h7EdwG5VlPX8uw++Y2aX2UHvMgRbImcLDz+/8qT1FR6dvujjyhwCgmUR9
/4+H8QkCw7M2ekFsODzSBzsEAIwTWuqYfwPRISyGTL/ajZC2WVxLNCC1NmvxzRMe
v/Mg344nxOrMG6MNTNYJdq/3dkiWBzXcpy5zWAVMxAiMDhKSytdk5mdvPI69wZtS
UZ92qXxvm/6fPjIoFy1hSII0LExLuS5p0MMZ7yFFEjZ4CQG/fPE04aUF0zAVgQQ8
OOjJA/0U+8ZlJnPF5cMfvODlOzjfG+LFhWS/t4NhJ12CWeOyn8+enAiXQsKyKyll
JtE9zf8aQKhfS1KJ/ZLZphmnN5LqQLOi/HVsAIK4/KPRrv7M4Z+atChLbmvvR31I
AcTOoDqxj4d8D8yiV8i+ZfLAXREPVLXc3c/W5gBrYwyp5bmpG7QUQXV0aG9yIG9m
IFRDR0lOQSBETEyIXgQTEQIAHgUCQjdxXAIbAwYLCQgHAwIDFQIDAxYCAQIeAQIX
gAAKCRD/R4xyQJdnzk9iAJ9rTCyGTUioEOJEU2w779rVzXoUkQCeO8zdw6QakpiA
uc2XmzGb6JscCEA=
=2DjS
-----END PGP PUBLIC KEY BLOCK-----
*/

#ifndef __KFIPRIV_H_D47DF546F16B490bA6D8523603A5594D
#define __KFIPRIV_H_D47DF546F16B490bA6D8523603A5594D

#include "kfi.h"
#include <tomcrypt.h>
#include "random.h"
#include "secmem.h"

#define KFI_ITERATION_COUNT  2000
#define KFI_HASH_NAME        "sha512"
#define KFI_HASH_DESC        sha512_desc
#define KFI_CIPHER1_NAME     "twofish"
#define KFI_CIPHER1_DESC     twofish_desc
#define KFI_CIPHER2_NAME     "aes"
#define KFI_CIPHER2_DESC     aes_desc

#define KFI_OFFSET2(s, elem) ((size_t) &((s *)0)->elem)
#define KFI_OFFSET(elem)     KFI_OFFSET2(KFI_DATA, elem)
#define KFI_DATA_OFFSET      KFI_OFFSET(dwSignature)
#define KFI_DATA_ENC_SIZE    (sizeof(KFI_DATA)-KFI_DATA_OFFSET)
#define KFI_DATA_SIZE        KFI_DATA_ENC_SIZE
#define KFI_MESSAGE_OFFSET   KFI_OFFSET(wVersion)
#define KFI_MESSAGE_SIZE     (sizeof(KFI_DATA)-KFI_MESSAGE_OFFSET)
#define KFI_TOTAL_KEY_SIZE   KFI_OFFSET2(KFI_ENCRYPTION_DATA, fValid)

#if KFI_CIPHER_BLOCK_SIZE == 16
#   define KFI_BlockXor(dest, src) \
      ((ULONG64 *)(dest))[0] ^= ((const ULONG64 *)(src))[0]; \
      ((ULONG64 *)(dest))[1] ^= ((const ULONG64 *)(src))[1];
#else
    static void KFI_BlockXor(void *dest, const void *src)
    {
        if ((KFI_CIPHER_BLOCK_SIZE & (sizeof(unsigned)-1)) == 0) {
            unsigned *puDest = (unsigned *)dest;
            unsigned *puDestEnd = puDest +
              KFI_CIPHER_BLOCK_SIZE / sizeof(unsigned);
            const unsigned *puSrc = (const unsigned *)src;
            while (puDest != puDestEnd) {
                *puDest++ ^= *puSrc++;
            }
        } else {
            BYTE *pbDest = (BYTE *)dest;
            BYTE *pbDestEnd = pbDest + KFI_CIPHER_BLOCK_SIZE;
            const BYTE *pbSrc = (const BYTE*)src;
            while (pbDest != pbDestEnd) {
                *pbDest++ ^= *pbSrc++;
            }
        }
    }
#endif

#ifdef __cplusplus
extern "C" {
#endif

DWORD calc_crc32(const void *data, size_t size);

#ifdef __cplusplus
}
#endif

#endif
