@echo off
if exist excerpt.7z goto :error

md excerpt

call :cpyi tomcrypt.h
call :cpyi tomcrypt_argchk.h
call :cpyi tomcrypt_cfg.h
call :cpyi tomcrypt_cipher.h
call :cpyi tomcrypt_custom.h
call :cpyi tomcrypt_hash.h
call :cpyi tomcrypt_mac.h
call :cpyi tomcrypt_macros.h
call :cpyi tomcrypt_misc.h
call :cpyi tomcrypt_pk.h
call :cpyi tomcrypt_pkcs.h
call :cpyi tomcrypt_prng.h

call :cpyc ciphers\aes\aes.c
call :cpyc ciphers\aes\aes_tab.c
call :cpyc ciphers\twofish\twofish.c
call :cpyc ciphers\twofish\twofish_tab.c
call :cpyc hashes\sha1.c
call :cpyc hashes\helper\hash_memory.c
call :cpyc hashes\sha2\sha256.c
call :cpyc hashes\sha2\sha512.c
call :cpyc mac\hmac\hmac_done.c
call :cpyc mac\hmac\hmac_init.c
call :cpyc mac\hmac\hmac_memory.c
call :cpyc mac\hmac\hmac_process.c
call :cpyc misc\crypt\crypt_cipher_descriptor.c
call :cpyc misc\crypt\crypt_find_cipher.c
call :cpyc misc\crypt\crypt_find_hash.c
call :cpyc misc\crypt\crypt_find_prng.c
call :cpyc misc\crypt\crypt_hash_descriptor.c
call :cpyc misc\crypt\crypt_hash_is_valid.c
call :cpyc misc\crypt\crypt_prng_descriptor.c
call :cpyc misc\crypt\crypt_prng_is_valid.c
call :cpyc misc\crypt\crypt_register_cipher.c
call :cpyc misc\crypt\crypt_register_hash.c
call :cpyc misc\crypt\crypt_register_prng.c
call :cpyc misc\pkcs5\pkcs_5_2.c
call :cpyc prngs\fortuna.c

7za a excerpt.7z excerpt\*.* -r -mx=9

goto :eof

:cpyi
copy headers\%1 excerpt\%1
goto :eof

:cpyc
copy %1 excerpt\%~n1%~x1
goto :eof

:error
cls
echo.ERROR: Cannot create "excerpt.7z" (file already exists)!
pause