/*
    Project: TCGINA (Setup V1.0m)
    Version: V1.15
    File   : fileinfo.h

    Copyright (c) 2005-2006 Author of TCGINA DLL. All rights reserved.

    Covered by TrueCrypt License 2.1 the full text of which is contained
    in the file License.txt included in TCGINA binary and source code
    distribution archives.

    The copyright notice of this source code file and the following public key
    must be retained in full.

-----BEGIN PGP PUBLIC KEY BLOCK-----
Version: GnuPG v1.2.4 (MingW32)

mQGiBEI3cVwRBADCRqJ1+AKeMw4BagfF9yNdobBBJXTFQ0R3RJHRAOoKMrT5rxMn
zjRvN9SugcTAftMRVTmsHVZcve6jO2yLHJLg2QgtHiRKdbLV9MTrzYtxXUL1Ez0A
3Mq6ww/h7EdwG5VlPX8uw++Y2aX2UHvMgRbImcLDz+/8qT1FR6dvujjyhwCgmUR9
/4+H8QkCw7M2ekFsODzSBzsEAIwTWuqYfwPRISyGTL/ajZC2WVxLNCC1NmvxzRMe
v/Mg344nxOrMG6MNTNYJdq/3dkiWBzXcpy5zWAVMxAiMDhKSytdk5mdvPI69wZtS
UZ92qXxvm/6fPjIoFy1hSII0LExLuS5p0MMZ7yFFEjZ4CQG/fPE04aUF0zAVgQQ8
OOjJA/0U+8ZlJnPF5cMfvODlOzjfG+LFhWS/t4NhJ12CWeOyn8+enAiXQsKyKyll
JtE9zf8aQKhfS1KJ/ZLZphmnN5LqQLOi/HVsAIK4/KPRrv7M4Z+atChLbmvvR31I
AcTOoDqxj4d8D8yiV8i+ZfLAXREPVLXc3c/W5gBrYwyp5bmpG7QUQXV0aG9yIG9m
IFRDR0lOQSBETEyIXgQTEQIAHgUCQjdxXAIbAwYLCQgHAwIDFQIDAxYCAQIeAQIX
gAAKCRD/R4xyQJdnzk9iAJ9rTCyGTUioEOJEU2w779rVzXoUkQCeO8zdw6QakpiA
uc2XmzGb6JscCEA=
=2DjS
-----END PGP PUBLIC KEY BLOCK-----
*/

#ifndef __FILEINFO_H_D47DF546F16B490bA6D8523603A5594D
#define __FILEINFO_H_D47DF546F16B490bA6D8523603A5594D

#define FILE_INFO_MAX_VERSION 40
#define FILE_INFO_HASH_SIZE   20

typedef struct {
    WIN32_FIND_DATA  fd;
    BOOL             fExists;
    BOOL             fInUse;
    TCHAR            szInfo[MAX_PATH];
    TCHAR            szOriginalFileName[MAX_PATH];
    TCHAR            szCompanyName[MAX_PATH];
    TCHAR            szFileVersion[FILE_INFO_MAX_VERSION];
    TCHAR            szFileDescription[MAX_PATH];
    TCHAR            szProductVersion[FILE_INFO_MAX_VERSION];
    TCHAR            szProductName[MAX_PATH];
    TCHAR            szCopyright[MAX_PATH];
    TCHAR            szVersion[FILE_INFO_MAX_VERSION];
    BYTE             rgbHashValue[FILE_INFO_HASH_SIZE];
    unsigned __int64 ullVersion;
    unsigned         uMajorVersion;
    unsigned         uMinorVersion;
    unsigned         uRelease;
    unsigned         uBuild;
} FILE_INFO, *PFILE_INFO;

struct s_FILE_INFO_LIST {
    struct s_FILE_INFO_LIST *pNextItem;
    FILE_INFO               fi;
};
typedef struct s_FILE_INFO_LIST FILE_INFO_LIST, *PFILE_INFO_LIST;

#ifdef __cplusplus
extern "C" {
#endif

BOOL GetFileInfo(PFILE_INFO pFileInfo, LPTSTR pszFileName);
LPCTSTR GetIniFileName(void);
BOOL GetInfoItem(LPCTSTR pszInfo, DWORD dwIndex, LPTSTR pszDest, DWORD nSize);

#ifdef __cplusplus
}
#endif


#endif
