/*
    Project: TCGINA (Setup V1.0m)
    Version: V1.15
    File   : setup.h

    Copyright (c) 2005-2006 Author of TCGINA DLL. All rights reserved.

    Covered by TrueCrypt License 2.1 the full text of which is contained
    in the file License.txt included in TCGINA binary and source code
    distribution archives.

    The copyright notice of this source code file and the following public key
    must be retained in full.

-----BEGIN PGP PUBLIC KEY BLOCK-----
Version: GnuPG v1.2.4 (MingW32)

mQGiBEI3cVwRBADCRqJ1+AKeMw4BagfF9yNdobBBJXTFQ0R3RJHRAOoKMrT5rxMn
zjRvN9SugcTAftMRVTmsHVZcve6jO2yLHJLg2QgtHiRKdbLV9MTrzYtxXUL1Ez0A
3Mq6ww/h7EdwG5VlPX8uw++Y2aX2UHvMgRbImcLDz+/8qT1FR6dvujjyhwCgmUR9
/4+H8QkCw7M2ekFsODzSBzsEAIwTWuqYfwPRISyGTL/ajZC2WVxLNCC1NmvxzRMe
v/Mg344nxOrMG6MNTNYJdq/3dkiWBzXcpy5zWAVMxAiMDhKSytdk5mdvPI69wZtS
UZ92qXxvm/6fPjIoFy1hSII0LExLuS5p0MMZ7yFFEjZ4CQG/fPE04aUF0zAVgQQ8
OOjJA/0U+8ZlJnPF5cMfvODlOzjfG+LFhWS/t4NhJ12CWeOyn8+enAiXQsKyKyll
JtE9zf8aQKhfS1KJ/ZLZphmnN5LqQLOi/HVsAIK4/KPRrv7M4Z+atChLbmvvR31I
AcTOoDqxj4d8D8yiV8i+ZfLAXREPVLXc3c/W5gBrYwyp5bmpG7QUQXV0aG9yIG9m
IFRDR0lOQSBETEyIXgQTEQIAHgUCQjdxXAIbAwYLCQgHAwIDFQIDAxYCAQIeAQIX
gAAKCRD/R4xyQJdnzk9iAJ9rTCyGTUioEOJEU2w779rVzXoUkQCeO8zdw6QakpiA
uc2XmzGb6JscCEA=
=2DjS
-----END PGP PUBLIC KEY BLOCK-----
*/

#ifndef __SETUP_H_D47DF546F16B490bA6D8523603A5594D
#define __SETUP_H_D47DF546F16B490bA6D8523603A5594D

#include "fileinfo.h"
#include "user.h"

#define WINLOGON_KEY \
  TEXT("SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Winlogon")
#define TCGINA_ROOT_KEY \
  TEXT("SOFTWARE\\TCGINA DLL")
#define TCGINA_KEY \
  TCGINA_ROOT_KEY TEXT("\\{D47DF546-F16B-490b-A6D8-523603A5594D}")
#define LSA_KEY \
  TEXT("SYSTEM\\CurrentControlSet\\Control\\Lsa")

#ifdef __cplusplus
extern "C" {
#endif

/* file.c */
BOOL FileExists(LPCTSTR pszFileName);
BOOL UninstallFile(LPCTSTR pszFileName, BOOL *fRebootRequired);
BOOL IsTcginaDLL(PFILE_INFO pfi);

/* reg.c */
BOOL RegKeyExists(HKEY hRootKey, LPCTSTR pszKeyName);
BOOL RegKeyIsEmpty(HKEY hRootKey, LPCTSTR pszKeyName);
BOOL RegValueExists(HKEY hRootKey, LPCTSTR pszKeyName, LPCTSTR pszValueName);
BOOL RegRemoveKey(HKEY hRootKey, LPCTSTR pszKeyName);
BOOL RegRemoveValue(HKEY hRootKey, LPCTSTR pszKeyName, LPCTSTR pszValueName);
BOOL RegCopyValue(HKEY hSrcRootKey, LPCTSTR pszSrcKeyName,
  LPCTSTR pszSrcValueName, HKEY hDestRootKey, LPCTSTR pszDestKeyName,
  LPCTSTR pszDestValueName);
BOOL RegCloneValue(HKEY hSrcRootKey, LPCTSTR pszSrcKeyName,
  LPCTSTR pszSrcValueName, HKEY hDestRootKey, LPCTSTR pszDestKeyName,
  LPCTSTR pszDestValueName);
BOOL RegGetValueData(HKEY hRootKey, LPCTSTR pszKeyName,
  LPCTSTR pszValueName, PDWORD pdwType, PBYTE pDest, PDWORD pcbSize);
BOOL RegSetString(HKEY hRootKey, LPCTSTR pszKeyName, LPCTSTR pszValueName,
  DWORD dwType, LPCTSTR pszValueData);
BOOL RegSetInteger(HKEY hRootKey, LPCTSTR pszKeyName, LPCTSTR pszValueName,
  DWORD dwData);
BOOL PendingFileRenameOperations(void);

#ifdef __cplusplus
}
#endif

#endif

