/*
    Project: TCGINA
    Version: V1.15
    File   : mediumdlg.c

    Copyright (c) 2005-2006 Author of TCGINA DLL. All rights reserved.

    Covered by TrueCrypt License 2.1 the full text of which is contained
    in the file License.txt included in TCGINA binary and source code
    distribution archives.

    The copyright notice of this source code file and the following public key
    must be retained in full.

-----BEGIN PGP PUBLIC KEY BLOCK-----
Version: GnuPG v1.2.4 (MingW32)

mQGiBEI3cVwRBADCRqJ1+AKeMw4BagfF9yNdobBBJXTFQ0R3RJHRAOoKMrT5rxMn
zjRvN9SugcTAftMRVTmsHVZcve6jO2yLHJLg2QgtHiRKdbLV9MTrzYtxXUL1Ez0A
3Mq6ww/h7EdwG5VlPX8uw++Y2aX2UHvMgRbImcLDz+/8qT1FR6dvujjyhwCgmUR9
/4+H8QkCw7M2ekFsODzSBzsEAIwTWuqYfwPRISyGTL/ajZC2WVxLNCC1NmvxzRMe
v/Mg344nxOrMG6MNTNYJdq/3dkiWBzXcpy5zWAVMxAiMDhKSytdk5mdvPI69wZtS
UZ92qXxvm/6fPjIoFy1hSII0LExLuS5p0MMZ7yFFEjZ4CQG/fPE04aUF0zAVgQQ8
OOjJA/0U+8ZlJnPF5cMfvODlOzjfG+LFhWS/t4NhJ12CWeOyn8+enAiXQsKyKyll
JtE9zf8aQKhfS1KJ/ZLZphmnN5LqQLOi/HVsAIK4/KPRrv7M4Z+atChLbmvvR31I
AcTOoDqxj4d8D8yiV8i+ZfLAXREPVLXc3c/W5gBrYwyp5bmpG7QUQXV0aG9yIG9m
IFRDR0lOQSBETEyIXgQTEQIAHgUCQjdxXAIbAwYLCQgHAwIDFQIDAxYCAQIeAQIX
gAAKCRD/R4xyQJdnzk9iAJ9rTCyGTUioEOJEU2w779rVzXoUkQCeO8zdw6QakpiA
uc2XmzGb6JscCEA=
=2DjS
-----END PGP PUBLIC KEY BLOCK-----
*/

#include <windows.h>
#include <tchar.h>
#include "misc.h"
#include "mediumdlg.h"

#define REFRESH_RATE 100

INT_PTR CALLBACK MediumDialogProc(HWND hwndDlg, UINT uMsg,
  WPARAM wParam, LPARAM lParam)
{
    PMEDIUM_DIALOG_DATA pmdd;

    switch (uMsg) {
    case WM_INITDIALOG:
        pmdd = (PMEDIUM_DIALOG_DATA) lParam;
        pmdd->dwStartTime = GetTickCount();
        if (pmdd->pszCaption) {
            SetWindowText(hwndDlg, pmdd->pszCaption);
        }
        if (pmdd->pszText) {
            HANDLE hwnd = GetDlgItem(hwndDlg, IDC_TEXT);
            SetWindowText(hwnd, pmdd->pszText);
        }
        if (pmdd->pfMediumAvailable == NULL) {
            EndDialog(hwndDlg, IDCANCEL);
            return TRUE;
        }
        SetWindowUserData(hwndDlg, pmdd);
        SetTimer(hwndDlg, 0, REFRESH_RATE, 0);
        return TRUE;

    case WM_TIMER: {
        pmdd = (PMEDIUM_DIALOG_DATA) GetWindowUserData(hwndDlg);

        if (pmdd->pfMediumAvailable(pmdd->pContext)) {
            PostMessage(hwndDlg, WM_COMMAND, IDOK, 0);
        } else if (pmdd->dwTimeout) {
            DWORD dwTime = GetTickCount();
            DWORD dwExpirationTime = pmdd->dwTimeout;
            if (dwTime > pmdd->dwStartTime) {
                dwExpirationTime += pmdd->dwStartTime;
            }
            if (dwTime > dwExpirationTime) {
                PostMessage(hwndDlg, WM_COMMAND, IDCANCEL, 0);
                pmdd->dwTimeout = 0;
            }
        }
        return TRUE; }

    case WM_COMMAND:
        switch (LOWORD(wParam)) {
        case IDOK:
        case IDCANCEL:
            KillTimer(hwndDlg, 0);
            EndDialog(hwndDlg, LOWORD(wParam));
            return TRUE;
        }
        break;
    }

    return FALSE;
}
