/*
    Project: TCGINA
    Version: V1.15
    File   : test.c

    Copyright (c) 2005-2006 Author of TCGINA DLL. All rights reserved.

    Covered by TrueCrypt License 2.1 the full text of which is contained
    in the file License.txt included in TCGINA binary and source code
    distribution archives.

    The copyright notice of this source code file and the following public key
    must be retained in full.

-----BEGIN PGP PUBLIC KEY BLOCK-----
Version: GnuPG v1.2.4 (MingW32)

mQGiBEI3cVwRBADCRqJ1+AKeMw4BagfF9yNdobBBJXTFQ0R3RJHRAOoKMrT5rxMn
zjRvN9SugcTAftMRVTmsHVZcve6jO2yLHJLg2QgtHiRKdbLV9MTrzYtxXUL1Ez0A
3Mq6ww/h7EdwG5VlPX8uw++Y2aX2UHvMgRbImcLDz+/8qT1FR6dvujjyhwCgmUR9
/4+H8QkCw7M2ekFsODzSBzsEAIwTWuqYfwPRISyGTL/ajZC2WVxLNCC1NmvxzRMe
v/Mg344nxOrMG6MNTNYJdq/3dkiWBzXcpy5zWAVMxAiMDhKSytdk5mdvPI69wZtS
UZ92qXxvm/6fPjIoFy1hSII0LExLuS5p0MMZ7yFFEjZ4CQG/fPE04aUF0zAVgQQ8
OOjJA/0U+8ZlJnPF5cMfvODlOzjfG+LFhWS/t4NhJ12CWeOyn8+enAiXQsKyKyll
JtE9zf8aQKhfS1KJ/ZLZphmnN5LqQLOi/HVsAIK4/KPRrv7M4Z+atChLbmvvR31I
AcTOoDqxj4d8D8yiV8i+ZfLAXREPVLXc3c/W5gBrYwyp5bmpG7QUQXV0aG9yIG9m
IFRDR0lOQSBETEyIXgQTEQIAHgUCQjdxXAIbAwYLCQgHAwIDFQIDAxYCAQIeAQIX
gAAKCRD/R4xyQJdnzk9iAJ9rTCyGTUioEOJEU2w779rVzXoUkQCeO8zdw6QakpiA
uc2XmzGb6JscCEA=
=2DjS
-----END PGP PUBLIC KEY BLOCK-----
*/

#include "tcg.h"
#include <tchar.h>

//#include "pwdlg.h"

#ifdef _MSC_VER
#  pragma warning( push )
#  pragma warning( disable : 4201 )
#endif
#include <winternl.h>
#ifdef _MSC_VER
#  pragma warning( pop )
#endif

/*-----------------------------------------------------------------------------
// GINA functions                                                            */

extern BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD dwReason, LPVOID lpReserved);

int WINAPI WlxMessageBox(HANDLE hWlx, HWND hwndOwner, LPWSTR lpszText,
  LPWSTR lpszTitle, UINT fuStyle)
{
    UNREFERENCED_PARAMETER(hWlx);

    return MessageBoxW(hwndOwner, lpszText, lpszTitle, fuStyle);
}

int WINAPI WlxDialogBoxParam(HANDLE hWlx, HANDLE hInst, LPWSTR lpszTemplate,
  HWND hwndOwner, DLGPROC dlgprc, LPARAM dwInitParam)
{
    UNREFERENCED_PARAMETER(hWlx);

    return (int)DialogBoxParamW((HINSTANCE)hInst, lpszTemplate, hwndOwner,
      dlgprc, dwInitParam);
}

/*-----------------------------------------------------------------------------
// WinMain                                                                   */

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
  LPSTR lpCmdLine, int nCmdShow)
{
    DWORD                      dwDllVersion;
    WLX_DISPATCH_VERSION_1_4   wdv14;
    TCG_CONTEXT                ctx;
    TCHAR                      szUserName[MAX_PATH];
    TCHAR                      szPassword[TC_MAX_PASSWORD];
    TCG_ENCRYPTED_PROFILE_INFO epiDefault;

#if 0
    PASSWORD_DIALOG_DATA pdd;
    char aszPassword[30];
    WCHAR wszTempPassword[30];
    memset(&pdd, '\0', sizeof(pdd));
    pdd.uCodePage = CP_UTF8;
    pdd.pPassword = aszPassword;
    pdd.cbPasswordSize = 29;
    pdd.pwszTempPassword = wszTempPassword;
    pdd.dwMinPasswordLength = 1;
    pdd.dwMaxPasswordLength = 29;

    DialogBoxParam(hInstance, MAKEINTRESOURCE(101), NULL,
      PasswordDialogProc, &pdd);
#endif

    UNREFERENCED_PARAMETER(hInstance);
    UNREFERENCED_PARAMETER(hPrevInstance);
    UNREFERENCED_PARAMETER(lpCmdLine);
    UNREFERENCED_PARAMETER(nCmdShow);

    ZeroMemory(&wdv14, sizeof(wdv14));
    wdv14.WlxMessageBox = WlxMessageBox;
    wdv14.WlxDialogBoxParam = WlxDialogBoxParam;

    ZeroMemory(&epiDefault, sizeof(epiDefault));
    ZeroMemory(&ctx, sizeof(ctx));
    ctx.pWlxFuncs = &wdv14;
    ctx.pProfileBegin = &epiDefault;
    ctx.fAutoMountDone = TRUE;

    _tcscpy(szUserName, TEXT("user"));
    _tcscpy(szPassword, TEXT("password"));

    DllMain(hInstance, DLL_PROCESS_ATTACH, NULL);

    dwDllVersion = WLX_VERSION_1_4;
    WlxNegotiate(dwDllVersion, &dwDllVersion);

    TCG_Logon(&ctx, szUserName, szPassword, L"");

    return 0;
}
